\subsection*{Implementing a reservoir transform}

In this context, a reservoir is a recurrent network of the form:

\centerline{\includegraphics[width=0.4\textwidth]{./recurrent-architecture.png}}

with recurrent equation\footnote{Using reservoir computing notations we read, in matrix form:
\eqline{
\mathbf{y}[t] = W_{out} \cdot \mathbf{x}[t] \;\;\;
\mathbf{x}[t+1] = l \, \mathbf{x}[t] + (1 - l) \, \sigma\left(\mathbf{W}_{in} \cdot \mathbf{u}[t+1] + \mathbf{W} \cdot \mathbf{x}[t]\right)}
which are equivalent with $y_o[t] \equiv x_{o}(t)$ and $x_n[t] \equiv x_{N_o+n}(t)$.}:
\eqline{\left\{ \begin{array}{rcll}
    x_o(t) &=&  \sum_{n \in \{N_0, N\{} W_{on}^{\mbox{o}} \, x_n(t)  & o < N_o \\
    x_n(t) &=& l \, x_n(t-1) + (1 - l) \, \sigma\left(\sum_{m = \{N_0, N\{} W_{nm} \, x_m(t-1) + \sum_{m = \{0, N_i\{} W_{ni}^{\mbox{i}} \, i_n(t)\right) & N_o \le n < N \\
\end{array}\right.}
writing:
\\ - $\sigma(\cdot)$ the normalized (i.e., $\sigma'(0) = 1$) sigmoid function $\sigma(x) \deq {1 \over 1 + \exp(-4 \, x)}$,
\\ - $W_{on}^{\mbox{o}}$ for the output weights,
\\ - $W_{ni}^{\mbox{i}}$ for the input weights,
\\ - $W_{nm}$ for the internal recurrent weights.
  
